/******************************************************************************/
/*                                                                            */
/* Modulname   :  PTEST.C                                                     */
/*                                                                            */
/* Interface   :  PTEST.H                                                     */
/*                                                                            */
/* Resourcen   :  PTEST.RC                                                    */
/*                                                                            */
/* Interface   :  RESOURCE.H                                                  */
/*                                                                            */
/* Beschreibung:  Tester fuer Mailslot-Schnittstelle                          */
/*                                                                            */
/* Copyright (C) MGW 1996 - All Rights Reserved                               */
/* -------------------------------------------------------------------------- */
/* Testoptionen: Compiler : MSVC 1.51                                         */
/*               Linker   : MSVC 1.51                                         */
/* -------------------------------------------------------------------------- */
/* Aenderungshistorie - Version 01.00                                         */
/*                                                                            */
/* Datum         Modifikation                                                 */
/* 23.01.96      Entwurf (MGW)                                                */
/* 26.03.96      Version 1.1 (MGW)                                            */
/* xx.xx.96      Version 1.2 (MGW)                                            */
/* 30.09.96      Version 1.3 AnsiToOem ergaenzt (MGW)                         */
/*                                                                            */
/* -------------------------------------------------------------------------- */
/*                                                                            */
/* Funktion           Kurzbeschreibung                                        */
/* ErrorBox                                                                   */
/* WriteMsg                                                                   */
/* EnableEdit                                                                 */
/* LimitText                                                                  */
/* InitMatrix                                                                 */
/* GenerateStringInc                                                          */
/* GenerateRandomDate                                                         */
/* GenerateRandomTime                                                         */
/*                                                                            */
/******************************************************************************/

/******************************************************************************/
/* Standard-Include-Dateien                                                   */
/******************************************************************************/
#include <windows.h>
#include <string.h>
#include <stdio.h>
#include <ctype.h> 
#include <stdlib.h> 

/******************************************************************************/
/* Programmglobale Include-Dateien                                            */
/******************************************************************************/

/******************************************************************************/
/* Eigene Include-Dateien                                                     */
/******************************************************************************/
#include "basetypw.h"
#include "siudate.h"
#include "ptest.h"
#include "resource.h"

/******************************************************************************/
/* Private Definitionen, Makros und Konstanten                                */
/******************************************************************************/
#ifndef EOS
#define EOS               '\0'
#endif

#define MAXLENSTRING       128
#define MAXLENPATH          96   
                    
/*----------------------------------------------------------------------------*/
/* Positionen innerhalb der Definitionsmatrix                                 */                       
/*----------------------------------------------------------------------------*/
#define NAME_ID              0                     
#define VORNAME_ID           1        
#define GEBURTSDATUM_ID      2        
#define EXT_KARTEINUMMER_ID  3        
#define NAME                 4        
#define VORNAME              5        
#define GEBURTSDATUM         6        
#define EXT_KARTEINUMMER     7        
#define GESCHLECHT           8        
#define STAMMBEHANDLER       9        
#define SCHWANGER           10        
#define STATION             11        
#define DATUM               12        
#define ZEIT                13        
#define SENDER              14        
#define EMPFAENGER          15        
#define AUFTRAGSNUMMER      16        
#define AUFNAHMENUMMER      17        
#define AUFNAHMETYP         18        
#define AUFNAHMEDATUM       19        
#define AUFNAHMEZEIT        20        
#define VERANTWORTLICHER    21        
#define BEGRUENDUNG         22        
#define BEFUND              23        
#define STRAHLDAUER         24        
#define ROEHRENSPANNUNG     25        
#define ANODENSTROM         26        
#define BILDDATEI           27

#define MATRIXMIN            0       /* Muss Null sein!                       */
#define MATRIXMAX           27       /* Letzte Index-Position                 */
/******************************************************************************/
/* Private Datentypen                                                         */
/******************************************************************************/

/******************************************************************************/
/* Externe Referenzen                                                         */
/******************************************************************************/
static HINSTANCE hInstGl;            /* Programm-Instanz                      */

static char MatrixAGl[MATRIXMAX+1];  /* Hier sind die Tokendefinitionen:      */
static char MatrixIGl[MATRIXMAX+1];  /*                                       */
static char MatrixMGl[MATRIXMAX+1];  /* Die Definition erfolgt in der         */
static char MatrixNGl[MATRIXMAX+1];  /* Funktion InitMatrix                   */
static char MatrixRGl[MATRIXMAX+1];  /*                                       */
static char MatrixSGl[MATRIXMAX+1];  /*                                       */
static char MatrixTGl[MATRIXMAX+1];  /*                                       */
static char MatrixUGl[MATRIXMAX+1];  /*                                       */
static char MatrixXGl[MATRIXMAX+1];  /*                                       */
static int  ResMtrxGl[MATRIXMAX+1];  /*                                       */

/******************************************************************************/
/* Prototypen der privaten Funktionen                                         */
/******************************************************************************/
static void   ErrorBox          ( HWND  hwnd, 
                                  int   Err, 
                                  LPSTR szInfo  );
static void   WriteMsg          ( HWND  hwnd, 
                                  char *Options, 
                                  char Token, 
                                  FILE *file );
static void   EnableEdit        ( HWND  hwnd, 
                                  char *Options );
static void   LimitText         ( HWND  hwnd, 
                                  BOOL  fLimit  );
static void   InitMatrix        ( void );
static BOOL   GenerateStringInc ( LPSTR lpszString );
static SIDATE GenerateRandomDate( SIDATE dateMax, 
                                  SIDATE dateMin );
static SITIME GenerateRandomTime( void );
                                           
/******************************************************************************/
/* Implementierung                                                            */
/******************************************************************************/


/******************************************************************************/
/*                                                                            */
/* Funktionsname: WinMain                                                     */
/*                                                                            */
/* Beschreibung : Die ueblich Einstiegfunktion                                */
/*                                                                            */
/* -------------------------------------------------------------------------- */
// Parameter    : SDK Standard
/*                                                                            */
/* Rueckgabewert: int                                                         */
/*                                                                            */
/* Bemerkungen  :                                                             */
/*                                                                            */
/* -------------------------------------------------------------------------- */
/* Aenderungshistorie - Version 01.00                                         */
/*                                                                            */
/* Datum    -    Modifikation                                                 */
/* 23.01.96      Entwurf (MGW)                                                */
/******************************************************************************/
int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int nCmdShow )
{
   DLGPROC lpfnDlgProc = NULL;       /*                                       */
   int     Res;                      /* Funktions-Ergebnisse                  */
   
   UNREFERENCED_PARAMETER( nCmdShow );
   UNREFERENCED_PARAMETER( lpszCmdLine );

   /*-------------------------------------------------------------------------*/
   /* Mehrfachstart unterbinden                                               */
   /*-------------------------------------------------------------------------*/
   hInstGl = hInstance;

   if (hPrevInstance) 
   {
      ErrorBox( NULL, IDS_NO_DIALOG, NULL );
      return 0;
   }
   /*-------------------------------------------------------------------------*/
   /* Hauptdialog                                                             */
   /*-------------------------------------------------------------------------*/
   lpfnDlgProc = (DLGPROC) MakeProcInstance( PTestMainDlgProc, hInstGl );

   if (!lpfnDlgProc) 
   { 
      ErrorBox( NULL, IDS_NO_DIALOG, NULL ); 
      return 0;
   }
   Res = DialogBox( hInstGl, MAKEINTRESOURCE( IDD_PTEST_SEND ), NULL, lpfnDlgProc );

   if (Res == -1)
   {
      ErrorBox( NULL, IDS_NO_DIALOG, NULL );
      FreeProcInstance( (FARPROC) lpfnDlgProc );    
      return 0;
   }              
   FreeProcInstance( lpfnDlgProc );

   /*-------------------------------------------------------------------------*/
   /* Ende                                                                    */
   /*-------------------------------------------------------------------------*/
   return 0;
}
                   
/******************************************************************************/
/*                                                                            */
/* Funktionsname: PTestMainDlgProc                                            */
/*                                                                            */
/* Beschreibung : Rckruffunktion fr das Hauptfenster                        */
/*                                                                            */
/* -------------------------------------------------------------------------- */
/* Parameter    : HWND                                                        */
/*                WORD                                                        */
/*                WORD                                                        */
/*                LONG                                                        */
/*                                                                            */
/* Rueckgabewert: LONG                                                        */
/*                                                                            */
/* Bemerkungen  :                                                             */
/*                                                                            */
/* -------------------------------------------------------------------------- */
/* Aenderungshistorie - Version 01.00                                         */
/*                                                                            */
/* Datum    -    Modifikation                                                 */
/* 23.01.96      Entwurf (MGW)                                                */
/*                                                                            */
/******************************************************************************/
BOOL CALLBACK PTestMainDlgProc( HWND hwnd, WORD wMsg, WPARAM wParam, LPARAM lParam )
{
   static char szIniFile [MAXLENPATH];      /* Name der Ini-Datei             */      
   static char szMailslot[MAXLENPATH];      /* Mailslot-Datei                 */
          int  Res;                         /* Funktions-Ergebnisse           */
   
   UNREFERENCED_PARAMETER( lParam );

   switch (wMsg)
   { 
      /*----------------------------------------------------------------------*/   
      /* Dialog initialisieren                                                */
      /*----------------------------------------------------------------------*/   
      case WM_INITDIALOG:
         /*-------------------------------------------------------------------*/
         /* Dialogbox zentrieren                                              */
         /*-------------------------------------------------------------------*/
         {
            RECT            rWnd;
            int             x, y, w, h;
            
            GetWindowRect( hwnd, &rWnd );         // Fenstergre

            w = rWnd.right  - rWnd.left;                /* Breite             */
            h = rWnd.bottom - rWnd.top;                 /* Hoehe              */
            x = (GetSystemMetrics(SM_CXSCREEN) - w) / 2;/* neuer linker  Rand */
            y = (GetSystemMetrics(SM_CYSCREEN) - h) / 2;/* neuer unterer Rand */

            x = ( x + 4 ) & ~7;                         /* Byteausrichtung    */

            MoveWindow( hwnd, x, y, w, h, TRUE );       // Zentrieren
         }
         /*-------------------------------------------------------------------*/
         /* Icon laden und zuweisen                                           */
         /*-------------------------------------------------------------------*/
         {
            HICON hIcon = LoadIcon( hInstGl, MAKEINTRESOURCE( IDI_ICON_PTEST ) );

            SetClassLong( hwnd, GCL_HICON, (LONG) hIcon );
         }
         /*-------------------------------------------------------------------*/
         /* Ini-Datei ermitteln                                               */
         /*-------------------------------------------------------------------*/
         {
            Res = GetModuleFileName( hInstGl, szIniFile, MAXLENPATH - 1 );
            if (!Res)
               strcpy( szIniFile, "C:\\PTEST.XYZ" );
//            *(_fstrrchr( szIniFile, '.' ) + 1) = '\0';
            *(strrchr( szIniFile, '.' ) + 1) = '\0';
            strcat( szIniFile, "INI" );
         }
         /*-------------------------------------------------------------------*/
         /* Initialisierung                                                   */
         /*-------------------------------------------------------------------*/
         {
            char szProgram[MAX_PATH];
            char szComputer[MAX_PATH];
            DWORD udwLen = MAX_PATH;

            InitMatrix();

            GetPrivateProfileString( "PTEST", "Mailslot", "C:\\sidexis.sdx", szMailslot, MAX_PATH, szIniFile );
            SetDlgItemText( hwnd, IDC_MAILSLOT, szMailslot );

            GetPrivateProfileString( "PTEST", "TaskSwitch", "C:\\SIDEXIS\\SIDEXIS.exe", szProgram, MAX_PATH, szIniFile );
            SetDlgItemText( hwnd, IDC_TASK, szProgram );

            szComputer[0] = '\0';
            (void) GetComputerName( szComputer, &udwLen );
            SetDlgItemText( hwnd, IDC_STATION, szComputer );
         }
         /*-------------------------------------------------------------------*/
         /* Ckeckboxen setzen, Feldlaengen begrenzen                          */
         /*-------------------------------------------------------------------*/
         {
            CheckDlgButton(hwnd, IDC_LIMITTEXT, TRUE);
            LimitText( hwnd, TRUE );
            
            CheckRadioButton(hwnd, IDC_A, IDC_X, IDC_A);
            SendMessage( hwnd, WM_COMMAND, IDC_A, 0L );
         }
         return( 0 );
      
      /*----------------------------------------------------------------------*/   
      /*                                                                      */
      /*----------------------------------------------------------------------*/   
      case WM_COMMAND:
      {
         switch( wParam )
         {              
            /*----------------------------------------------------------------*/
            /* Token                                                          */
            /*----------------------------------------------------------------*/
            case IDC_A: EnableEdit( hwnd, MatrixAGl ); break;         
            case IDC_I: EnableEdit( hwnd, MatrixIGl ); break;         
            case IDC_M: EnableEdit( hwnd, MatrixMGl ); break;         
            case IDC_N: EnableEdit( hwnd, MatrixNGl ); break;         
            case IDC_R: EnableEdit( hwnd, MatrixRGl ); break;         
            case IDC_S: EnableEdit( hwnd, MatrixSGl ); break;         
            case IDC_T: EnableEdit( hwnd, MatrixTGl ); break;         
            case IDC_U: EnableEdit( hwnd, MatrixUGl ); break;         
            case IDC_X: EnableEdit( hwnd, MatrixXGl ); break;         
            case IDC_RADIO10: break;
            case IDC_RADIO11: break;
            case IDC_RADIO12: break;
            
            /*----------------------------------------------------------------*/
            /* Feldlaengenbegrenzer                                           */
            /*----------------------------------------------------------------*/
            case IDC_LIMITTEXT:                 
               LimitText( hwnd, IsDlgButtonChecked( hwnd, IDC_LIMITTEXT ) );
               break;
            
            /*----------------------------------------------------------------*/
            /* Aboutbox                                                       */                
            /*----------------------------------------------------------------*/
            case IDC_ABOUT:
            {
               DLGPROC lpfnDlgProc = (DLGPROC) MakeProcInstance( AboutDlgProc, hInstGl );
               int     Res;                   
            
               if (!lpfnDlgProc) 
               { 
                  ErrorBox( hwnd, IDS_NO_DIALOG, NULL ); 
                  break; 
               }
               Res = DialogBox( hInstGl, MAKEINTRESOURCE( IDD_PTEST_ABOUT ), hwnd, lpfnDlgProc );  

               if (Res == -1)
               {
                  ErrorBox( hwnd, IDS_NO_DIALOG, NULL );
                  FreeProcInstance( (FARPROC) lpfnDlgProc );
                  break;
               }              
               FreeProcInstance( (FARPROC) lpfnDlgProc );    
               break;
            }  
            /*----------------------------------------------------------------*/
            /* Neue Testdaten erzeugen                                        */
            /*----------------------------------------------------------------*/
            case IDC_TESTDATA:
            {
               char      szBuf [MAXLENSTRING];         /* zum Felder lesen    */
               
               char      szDate[11];                   /* Datum               */
               char      szTime[11];                   /* Zeit                */
               
               UWORD     uwYear;                       /* Jahr                */
               UBYTE     ubMonth;                      /* Monat               */
               UBYTE     ubDay;                        /* Tag                 */
               UBYTE     ubHour;                       /* Stunde              */
               UBYTE     ubMinute;                     /* Minute              */
               UBYTE     ubSecond;                     /* Sekunde             */
               
               SIDATE    dateAct;                      /* Aktuelles Datum     */
               SIDATE    dateRes;                      /* Berechnetes Dat.    */
               SIDATE    dateMin, dateMax;             /* Grenz-Daten         */
               SITIME    timeRes;                      /* Berechnete Zeit     */
               
               BOOL      fsex, fpregnant;              /* weiblich/schwanger  */
               
               char      szType[5];                    /* Aufnahmetyp         */
               
               /*-------------------------------------------------------------*/
               /* Aktuelle Zeit und Datum eintragen                           */
               /*-------------------------------------------------------------*/
               GetActDate( &uwYear, &ubMonth , &ubDay    );
               GetActTime( &ubHour, &ubMinute, &ubSecond );
               DateToStr( uwYear, ubMonth , ubDay   , szDate, "DD.MM.YYYY" );
               TimeToStr( ubHour, ubMinute, ubSecond, szTime, "HH:MM:SS"   );
               SetWindowText( GetDlgItem( hwnd, IDC_DATUM ), szDate );   
               SetWindowText( GetDlgItem( hwnd, IDC_ZEIT  ), szTime );   
               
               /*-------------------------------------------------------------*/
               /* Aktuelles Datum, fuer spaeter merken                        */
               /*-------------------------------------------------------------*/
               dateAct.uwYear  = uwYear; 
               dateAct.ubMonth = ubMonth;
               dateAct.ubDay   = ubDay;
               
               /*-------------------------------------------------------------*/
               /* Namen und Vornamen usw. inkrementieren                      */
               /*-------------------------------------------------------------*/
#define MY_STR_INC(x)  GetWindowText( GetDlgItem(hwnd,(x)), szBuf, MAXLENSTRING); \
                       GenerateStringInc( (LPSTR)szBuf );                         \
                       SetWindowText( GetDlgItem(hwnd,(x)), szBuf )   
               
               MY_STR_INC( IDC_NAME_ID             );   
               MY_STR_INC( IDC_VORNAME_ID          );      
               MY_STR_INC( IDC_EXT_KARTEINUMMER_ID );      
               MY_STR_INC( IDC_NAME                );      
               MY_STR_INC( IDC_VORNAME             );      
               MY_STR_INC( IDC_EXT_KARTEINUMMER    );      
               MY_STR_INC( IDC_AUFTRAGSNUMMER      );      
               MY_STR_INC( IDC_AUFNAHMENUMMER      );      
               MY_STR_INC( IDC_BEGRUENDUNG         );      
               MY_STR_INC( IDC_BEFUND              );      

#undef  MY_STR_INC                       
               
               /*-------------------------------------------------------------*/
               /* Zufaelliges Geburtsdatum setzen                             */
               /*-------------------------------------------------------------*/
               dateMin.uwYear  = 1920;             /* Aelter wird heir keiner */
               dateMin.ubMonth = 1;
               dateMin.ubDay   = 1;
               dateMax.uwYear  = dateAct.uwYear - 4; /* Juengste Patienten    */
               dateMax.ubMonth = 12;
               dateMax.ubDay   = 31;
               
               dateRes = GenerateRandomDate( dateMax, dateMin );
               DateToStr( dateRes.uwYear, dateRes.ubMonth, dateRes.ubDay, szBuf, "DD.MM.YYYY" );
               SetWindowText( GetDlgItem( hwnd, IDC_GEBURTSDATUM_ID ), szBuf );  
               
               dateRes = GenerateRandomDate( dateAct, dateMin );
               DateToStr( dateRes.uwYear, dateRes.ubMonth, dateRes.ubDay, szBuf, "DD.MM.YYYY" );
               SetWindowText( GetDlgItem( hwnd, IDC_GEBURTSDATUM    ), szBuf );  

               /*-------------------------------------------------------------*/
               /* Zufllige Aufnahmezeit und -datum setzen                    */
               /*-------------------------------------------------------------*/
               dateMin.uwYear  = 1990;        /* Vorher gab's keine Aufnahmen */
               dateMin.ubMonth = 1;
               dateMin.ubDay   = 1;           
               
               dateRes = GenerateRandomDate( dateAct, dateMin );
               DateToStr( dateRes.uwYear, dateRes.ubMonth, dateRes.ubDay, szBuf, "DD.MM.YYYY" );
               SetWindowText( GetDlgItem( hwnd, IDC_AUFNAHMEDATUM ),szBuf );  
               
               timeRes = GenerateRandomTime ();
               TimeToStr( timeRes.ubHour, timeRes.ubMinute, timeRes.ubSecond, szBuf, "HH:MM:SS" );
               SetWindowText( GetDlgItem( hwnd, IDC_AUFNAHMEZEIT  ),szBuf );  
               
               /*-------------------------------------------------------------*/
               /* Geschlecht und ob schwanger wenn weiblich                   */
               /*-------------------------------------------------------------*/
               fsex = (BOOL)( rand() % 2 );                 /* weiblich  1/2  */
               fpregnant = fsex && !(BOOL)(rand()%30);      /* schwanger 1/30 */  
               SetWindowText( GetDlgItem( hwnd, IDC_GESCHLECHT ), fsex      ? "W" : "M" );   
               SetWindowText( GetDlgItem( hwnd, IDC_SCHWANGER  ), fpregnant ? "Y" : "N" );   
               
               /*----------------------------------------------------------*/
               /* Aufnahmetyp Video oder Roentgen 1:24                     */                    
               /*----------------------------------------------------------*/
               szType[4] = EOS;
               szType[3] = ' ';
               szType[2] = (char)(((rand()%25)>0) ? 'X' : 'V');
               szType[1] = ' ';
               szType[0] = ' ';
                 
               switch( szType[2] )
               {
                  /*-------------------------------------------------------*/
                  /* Videoaufnahme                                         */
                  /*-------------------------------------------------------*/
                  case 'V':
                     szType[3] = 'I';
                     szType[0] = (char)('1' + (rand() % 4));
                     szType[1] = (char)('1' + (rand() % 8));
                     break;
                   
                  /*-------------------------------------------------------*/
                  /* Roentgenaufnahmen                                     */
                  /*-------------------------------------------------------*/
                  case 'X':

                     switch( rand() % 3 )
                     {
                        case 0:
                           /*----------------------------------------------*/
                           /* Intraoral                                    */
                           /*----------------------------------------------*/
                           szType[3] = 'I';
                           szType[0] = (char)('1' + (rand() % 4));
                           szType[1] = (char)('1' + (rand() % 8));
                           break;
                       
                        case 1:
                           /*----------------------------------------------*/
                           /* Ceph                                         */
                           /*----------------------------------------------*/
                           szType[3] = 'C';
                           szType[0] = (char)('1' + (rand() % 2));
                           szType[1] = (char)('1' + (rand() % 2));
                           break;
                       
                        case 2:
                           /*----------------------------------------------*/
                           /* Panorama                                     */
                           /*----------------------------------------------*/
                           szType[3] = 'P';
                           wsprintf( szType, "%2.2d", (1+rand()%16) );
                           szType[2] = 'X';     /* wegen Null von wsprintf */
                           break;
                       
                        default:   
                           /*----------------------------------------------*/
                           /* Unbekannt (sollte nicht eintreten)           */
                           /*----------------------------------------------*/
                           szType[3] = '?';
                           szType[0] = '~';
                           szType[1] = '~';
                           break;
                     }
                     break; 
                   
                  default:  
                  /*-------------------------------------------------------*/
                  /* Unbekannt (sollte nicht eintreten)                    */
                  /*-------------------------------------------------------*/
                     szType[2] = '?';
                     szType[3] = '?';
                     szType[0] = '~';
                     szType[1] = '~';
                     break;   
               }
               SetWindowText( GetDlgItem( hwnd, IDC_AUFNAHMETYP ), szType );   
               if (IsDlgButtonChecked( hwnd, IDC_LIMITTEXT ))
                  LimitText( hwnd, TRUE );
               break;
            }
            /*----------------------------------------------------------------*/
            /* Neue (aktuelle) Testzeit erzeugen                              */
            /*----------------------------------------------------------------*/
            case IDC_TESTTIME:
            {
               char      szDate[11];                   /* Datum               */
               char      szTime[11];                   /* Zeit                */
               
               UWORD     uwYear;                       /* Jahr                */
               UBYTE     ubMonth;                      /* Monat               */
               UBYTE     ubDay;                        /* Tag                 */
               UBYTE     ubHour;                       /* Stunde              */
               UBYTE     ubMinute;                     /* Minute              */
               UBYTE     ubSecond;                     /* Sekunde             */
               
               /*-------------------------------------------------------------*/
               /* Aktuelle Zeit und Datum eintragen                           */
               /*-------------------------------------------------------------*/
               GetActDate( &uwYear, &ubMonth , &ubDay    );
               GetActTime( &ubHour, &ubMinute, &ubSecond );
               DateToStr( uwYear, ubMonth , ubDay   , szDate, "DD.MM.YYYY" );
               TimeToStr( ubHour, ubMinute, ubSecond, szTime, "HH:MM:SS"   );

               SetWindowText( GetDlgItem( hwnd, IDC_DATUM ), szDate );   
               SetWindowText( GetDlgItem( hwnd, IDC_ZEIT  ), szTime );   

               break;
            }
            /*----------------------------------------------------------------*/
            /* Testdaten laden (aus Ini)                                      */
            /*----------------------------------------------------------------*/
            case IDC_LOAD:
            {
               char   szBuf[MAXLENSTRING];

#define MY_STR_READ(x,y,z) GetPrivateProfileString( "Testdaten",(x),(y),szBuf, \
                                                    MAXLENSTRING, szIniFile  );\
                           SetWindowText( GetDlgItem(hwnd,(z)), szBuf)           
              
               
               MY_STR_READ( "NAME_ID"            , "Name"        , IDC_NAME_ID            );
               MY_STR_READ( "VORNAME_ID"         , "FirstName"   , IDC_VORNAME_ID         );    
               MY_STR_READ( "GEBURTSDATUM_ID"    , "01.01.1971"  , IDC_GEBURTSDATUM_ID    );  
               MY_STR_READ( "EXT_KARTEINUMMER_ID", "ExtID00001"  , IDC_EXT_KARTEINUMMER_ID);     
               MY_STR_READ( "NAME"               , "Name"        , IDC_NAME               );    
               MY_STR_READ( "VORNAME"            , "FirstName"   , IDC_VORNAME            );     
               MY_STR_READ( "GEBURTSDATUM"       , "02.02.1972"  , IDC_GEBURTSDATUM       );   
               MY_STR_READ( "EXT_KARTEINUMMER"   , "EXTID00002"  , IDC_EXT_KARTEINUMMER   );  
               MY_STR_READ( "GESCHLECHT"         , "M"           , IDC_GESCHLECHT         );   
               MY_STR_READ( "STAMMBEHANDLER"     , "MGW"         , IDC_STAMMBEHANDLER     );     
               MY_STR_READ( "SCHWANGER"          , "N"           , IDC_SCHWANGER          );     
               MY_STR_READ( "STATION"            , "Station"     , IDC_STATION            );    
               MY_STR_READ( "ZEIT"               , "13:03:03"    , IDC_ZEIT               );   
               MY_STR_READ( "DATUM"              , "03.03.1996"  , IDC_DATUM              );   
               MY_STR_READ( "SENDER"             , "Sender"      , IDC_SENDER             );     
               MY_STR_READ( "EMPFAENGER"         , "Receiver"    , IDC_EMPFAENGER         );     
               MY_STR_READ( "AUFTRAGSNUMMER"     , "12345"       , IDC_AUFTRAGSNUMMER     );     
               MY_STR_READ( "AUFNAHMENUMMER"     , "10001"       , IDC_AUFNAHMENUMMER     );     
               MY_STR_READ( "AUFNAHMETYP"        , "11XI"        , IDC_AUFNAHMETYP        );   
               MY_STR_READ( "AUFNAHMEDATUM"      , "04.04.1995"  , IDC_AUFNAHMEDATUM      );    
               MY_STR_READ( "AUFNAHMEZEIT"       , "04:04:04"    , IDC_AUFNAHMEZEIT       );     
               MY_STR_READ( "VERANTWORTLICHER"   , "Siemens"     , IDC_VERANTWORTLICHER   );      
               MY_STR_READ( "BEGRUENDUNG"        , "Reason"      , IDC_BEGRUENDUNG        );    
               MY_STR_READ( "BEFUND"             , "Diagnosis"   , IDC_BEFUND             );    
               MY_STR_READ( "STRAHLDAUER"        , "40"          , IDC_STRAHLDAUER        );     
               MY_STR_READ( "ROEHRENSPANNUNG"    , "70"          , IDC_ROEHRENSPANNUNG    );     
               MY_STR_READ( "ANODENSTROM"        , "7"           , IDC_ANODENSTROM        );      
               MY_STR_READ( "BILDDATEI"          , "C:\\Bild.TIF", IDC_BILDDATEI          );     

#undef  MY_STR_READ

               if (IsDlgButtonChecked( hwnd, IDC_LIMITTEXT ))
                  LimitText( hwnd, TRUE );
               break;
            }
            /*----------------------------------------------------------------*/
            /* Testdaten speichern                                            */
            /*----------------------------------------------------------------*/
            case IDC_SAVE:
            {
               char szBuf[MAXLENSTRING];

#define MY_STR_WRITE(x,z) GetWindowText( GetDlgItem(hwnd,(z)),szBuf,MAXLENSTRING);   \
                          WritePrivateProfileString("Testdaten",(x),szBuf,szIniFile)

               MY_STR_WRITE( "NAME_ID"            , IDC_NAME_ID            );
               MY_STR_WRITE( "VORNAME_ID"         , IDC_VORNAME_ID         );    
               MY_STR_WRITE( "GEBURTSDATUM_ID"    , IDC_GEBURTSDATUM_ID    );  
               MY_STR_WRITE( "EXT_KARTEINUMMER_ID", IDC_EXT_KARTEINUMMER_ID);     
               MY_STR_WRITE( "NAME"               , IDC_NAME               );    
               MY_STR_WRITE( "VORNAME"            , IDC_VORNAME            );     
               MY_STR_WRITE( "GEBURTSDATUM"       , IDC_GEBURTSDATUM       );   
               MY_STR_WRITE( "EXT_KARTEINUMMER"   , IDC_EXT_KARTEINUMMER   );  
               MY_STR_WRITE( "GESCHLECHT"         , IDC_GESCHLECHT         );   
               MY_STR_WRITE( "STAMMBEHANDLER"     , IDC_STAMMBEHANDLER     );     
               MY_STR_WRITE( "SCHWANGER"          , IDC_SCHWANGER          );     
               MY_STR_WRITE( "STATION"            , IDC_STATION            );    
               MY_STR_WRITE( "ZEIT"               , IDC_ZEIT               );   
               MY_STR_WRITE( "DATUM"              , IDC_DATUM              );   
               MY_STR_WRITE( "SENDER"             , IDC_SENDER             );     
               MY_STR_WRITE( "EMPFAENGER"         , IDC_EMPFAENGER         );     
               MY_STR_WRITE( "AUFTRAGSNUMMER"     , IDC_AUFTRAGSNUMMER     );     
               MY_STR_WRITE( "AUFNAHMENUMMER"     , IDC_AUFNAHMENUMMER     );     
               MY_STR_WRITE( "AUFNAHMETYP"        , IDC_AUFNAHMETYP        );   
               MY_STR_WRITE( "AUFNAHMEDATUM"      , IDC_AUFNAHMEDATUM      );    
               MY_STR_WRITE( "AUFNAHMEZEIT"       , IDC_AUFNAHMEZEIT       );     
               MY_STR_WRITE( "VERANTWORTLICHER"   , IDC_VERANTWORTLICHER   );      
               MY_STR_WRITE( "BEGRUENDUNG"        , IDC_BEGRUENDUNG        );    
               MY_STR_WRITE( "BEFUND"             , IDC_BEFUND             );    
               MY_STR_WRITE( "STRAHLDAUER"        , IDC_STRAHLDAUER        );     
               MY_STR_WRITE( "ROEHRENSPANNUNG"    , IDC_ROEHRENSPANNUNG    );     
               MY_STR_WRITE( "ANODENSTROM"        , IDC_ANODENSTROM        );      
               MY_STR_WRITE( "BILDDATEI"          , IDC_BILDDATEI          );     
#undef  MY_STR_WRITE
               break;
            }
            /*----------------------------------------------------------------*/
            /* Testdaten loeschen                                             */
            /*----------------------------------------------------------------*/
            case IDC_DELETE:
               SetWindowText( GetDlgItem( hwnd, IDC_NAME_ID             ), "" );
               SetWindowText( GetDlgItem( hwnd, IDC_VORNAME_ID          ), "" );    
               SetWindowText( GetDlgItem( hwnd, IDC_GEBURTSDATUM_ID     ), "" );  
               SetWindowText( GetDlgItem( hwnd, IDC_EXT_KARTEINUMMER_ID ), "" );     
               SetWindowText( GetDlgItem( hwnd, IDC_NAME                ), "" );    
               SetWindowText( GetDlgItem( hwnd, IDC_VORNAME             ), "" );     
               SetWindowText( GetDlgItem( hwnd, IDC_GEBURTSDATUM        ), "" );   
               SetWindowText( GetDlgItem( hwnd, IDC_EXT_KARTEINUMMER    ), "" );  
               SetWindowText( GetDlgItem( hwnd, IDC_GESCHLECHT          ), "" );   
               SetWindowText( GetDlgItem( hwnd, IDC_STAMMBEHANDLER      ), "" );     
               SetWindowText( GetDlgItem( hwnd, IDC_SCHWANGER           ), "" );     
               SetWindowText( GetDlgItem( hwnd, IDC_STATION             ), "" );    
               SetWindowText( GetDlgItem( hwnd, IDC_DATUM               ), "" );   
               SetWindowText( GetDlgItem( hwnd, IDC_ZEIT                ), "" );   
               SetWindowText( GetDlgItem( hwnd, IDC_SENDER              ), "" );     
               SetWindowText( GetDlgItem( hwnd, IDC_EMPFAENGER          ), "" );     
               SetWindowText( GetDlgItem( hwnd, IDC_AUFTRAGSNUMMER      ), "" );     
               SetWindowText( GetDlgItem( hwnd, IDC_AUFNAHMENUMMER      ), "" );     
               SetWindowText( GetDlgItem( hwnd, IDC_AUFNAHMETYP         ), "" );   
               SetWindowText( GetDlgItem( hwnd, IDC_AUFNAHMEDATUM       ), "" );    
               SetWindowText( GetDlgItem( hwnd, IDC_AUFNAHMEZEIT        ), "" );     
               SetWindowText( GetDlgItem( hwnd, IDC_VERANTWORTLICHER    ), "" );      
               SetWindowText( GetDlgItem( hwnd, IDC_BEGRUENDUNG         ), "" );    
               SetWindowText( GetDlgItem( hwnd, IDC_BEFUND              ), "" );    
               SetWindowText( GetDlgItem( hwnd, IDC_STRAHLDAUER         ), "" );     
               SetWindowText( GetDlgItem( hwnd, IDC_ROEHRENSPANNUNG     ), "" );     
               SetWindowText( GetDlgItem( hwnd, IDC_ANODENSTROM         ), "" );      
               SetWindowText( GetDlgItem( hwnd, IDC_BILDDATEI           ), "" );     
               break;

            //-----------------------------------------------------------------
            // Taskwechsel
            //-----------------------------------------------------------------
            case IDC_TASKSWITCH:
            {
               char szProgram[MAXLENPATH];
               UINT nRet;

               GetDlgItemText( hwnd, IDC_TASK, szProgram, MAXLENPATH ); 
               WritePrivateProfileString( "PTEST", "Taskswitch", szProgram, szIniFile );
               nRet = WinExec( szProgram, SW_SHOWNORMAL );
               if (nRet < 32)
                  MessageBeep( MB_ICONSTOP );
               break;
            }
            case IDC_OPEN_EXE:
            {
               char szFile[MAX_PATH];
               OPENFILENAME ofn;
               char         szFilter[32];

               szFile[0] = '\0';
               GetDlgItemText( hwnd, IDC_TASK, szFile, MAX_PATH ); 

               if (!strlen( szFile ) )
                  (void) strcpy( szFile, "c:\\*.exe" );

               ZeroMemory( szFilter, 32 );

               (void) strcpy( szFilter, "Application " );
               (void) strcpy( szFilter + strlen( szFilter ), "(*.exe)" );

               ZeroMemory( &ofn, sizeof( OPENFILENAME ) );

               ofn.lStructSize = sizeof( OPENFILENAME );
               ofn.hwndOwner   = hwnd;
               ofn.lpstrFilter = szFilter;
               ofn.lpstrFile   = szFile;
               ofn.nMaxFile    = MAX_PATH;
               ofn.Flags       = OFN_HIDEREADONLY | OFN_NOREADONLYRETURN | OFN_PATHMUSTEXIST;
               ofn.lpstrDefExt = "exe";

               if (GetOpenFileName( &ofn ) )
                  (void) SetDlgItemText( hwnd, IDC_TASK, ofn.lpstrFile );
               break;
            }
            case IDC_OPEN_SDX:
            {
               char szFile[MAX_PATH];
               OPENFILENAME ofn;
               char         szFilter[32];

               szFile[0] = '\0';
               GetDlgItemText( hwnd, IDC_MAILSLOT, szFile, MAX_PATH ); 

               if (!strlen( szFile ) )
                  (void) strcpy( szFile, "c:\\*.exe" );

               ZeroMemory( szFilter, 32 );

               (void) strcpy( szFilter, "SLIDA Mailslot " );
               (void) strcpy( szFilter + strlen( szFilter ), "(*.sdx)" );

               ZeroMemory( &ofn, sizeof( OPENFILENAME ) );

               ofn.lStructSize = sizeof( OPENFILENAME );
               ofn.hwndOwner   = hwnd; 
               ofn.lpstrFilter = szFilter;
               ofn.lpstrFile   = szFile;
               ofn.nMaxFile    = MAX_PATH;
               ofn.Flags       = OFN_HIDEREADONLY | OFN_NOREADONLYRETURN | OFN_PATHMUSTEXIST;
               ofn.lpstrDefExt = "sdx";

               if (GetOpenFileName( &ofn ) )
                  (void) SetDlgItemText( hwnd, IDC_MAILSLOT, ofn.lpstrFile );
               break;
            }
            /*----------------------------------------------------------------*/
            /* Schliessen                                                     */
            /*----------------------------------------------------------------*/
            case IDCANCEL:
               GetDlgItemText( hwnd, IDC_MAILSLOT, szMailslot, MAXLENPATH ); 
               WritePrivateProfileString( "PTEST", "Mailslot", szMailslot, szIniFile );
               EndDialog( hwnd, TRUE );
               break;            
               
            /*----------------------------------------------------------------*/
            /* Senden                                                         */
            /*----------------------------------------------------------------*/
            case IDOK:
            {
               FILE *Mailslot;
               
               /*-------------------------------------------------------------*/
               /* Message schreiben                                           */
               /*-------------------------------------------------------------*/
               GetDlgItemText( hwnd, IDC_MAILSLOT, szMailslot, MAXLENPATH ); 
               Mailslot = fopen( szMailslot, "ab" );

               if (!Mailslot)
               {
                  ErrorBox( hwnd, IDS_ERR_OPEN, szMailslot );
                  break; 
               }
               fseek( Mailslot, 0, SEEK_END );
               if (IsDlgButtonChecked( hwnd, IDC_A ) )
                  WriteMsg( hwnd, MatrixAGl, 'A', Mailslot );
               if (IsDlgButtonChecked( hwnd, IDC_I ) )
                  WriteMsg( hwnd, MatrixIGl, 'I', Mailslot );
               if (IsDlgButtonChecked( hwnd, IDC_M ) )
                  WriteMsg( hwnd, MatrixMGl, 'M', Mailslot );
               if (IsDlgButtonChecked( hwnd, IDC_N ) )
                  WriteMsg( hwnd, MatrixNGl, 'N', Mailslot );
               if (IsDlgButtonChecked( hwnd, IDC_R ) )
                  WriteMsg( hwnd, MatrixRGl, 'R', Mailslot );
               if (IsDlgButtonChecked( hwnd, IDC_S ) )
                  WriteMsg( hwnd, MatrixSGl, 'S', Mailslot );
               if (IsDlgButtonChecked( hwnd, IDC_T ) )
                  WriteMsg( hwnd, MatrixTGl, 'T', Mailslot );
               if (IsDlgButtonChecked( hwnd, IDC_U ) )
                  WriteMsg( hwnd, MatrixUGl, 'U', Mailslot );
               if (IsDlgButtonChecked( hwnd, IDC_X ) )
                  WriteMsg( hwnd, MatrixXGl, 'X', Mailslot );
               fclose( Mailslot );
               break;    
            }   
         }   
      } 
      break;
   }
   return 0;
}
          
/******************************************************************************/
/*                                                                            */
/* Funktionsname: AboutDlgProc                                                */
/*                                                                            */
/* Beschreibung : Rckruffunktion fr den "About" - Dialog                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
/* Parameter    : HWND                                                        */
/*                WORD                                                        */
/*                WORD                                                        */
/*                LONG                                                        */
/*                                                                            */
/* Rueckgabewert: BOOL                                                        */
/*                                                                            */
/* Bemerkungen  :                                                             */
/*                                                                            */
/* -------------------------------------------------------------------------- */
/* Aenderungshistorie - Version 01.00                                         */
/*                                                                            */
/* Datum    -    Modifikation                                                 */
/* 23.01.96      Entwurf (MGW)                                                */
/*                                                                            */
/******************************************************************************/
BOOL CALLBACK AboutDlgProc ( HWND hdlg, WORD wMsg, WPARAM wParam, LPARAM lParam )
{
   UNREFERENCED_PARAMETER( lParam );

   switch (wMsg) 
   {
      /*----------------------------------------------------------------------*/   
      /* Dialog initialisieren                                                */
      /*----------------------------------------------------------------------*/   
      case WM_INITDIALOG:
         /*-------------------------------------------------------------------*/
         /* Dialogbox zentrieren                                              */
         /*-------------------------------------------------------------------*/
      {
         RECT rWnd;
         int  x, y, w, h;
         
         GetWindowRect( hdlg, (RECT*) &rWnd );       // Fenstergre
         w = rWnd.right  - rWnd.left;                /* Breite             */
         h = rWnd.bottom - rWnd.top;                 /* Hoehe              */
         x = (GetSystemMetrics( SM_CXSCREEN ) - w) / 2;// Neuer linker  Rand
         y = (GetSystemMetrics( SM_CYSCREEN ) - h) / 2;// Neuer unterer Rand
         x = (x + 4) & ~7;                           // Byteausrichtung
         MoveWindow( hdlg, x, y, w, h, TRUE );       // Zentrieren
         return 0;
      }   
      /*----------------------------------------------------------------------*/   
      /*                                                                      */
      /*----------------------------------------------------------------------*/   
      case WM_COMMAND:
      {
         if (wParam == IDOK)
         {
            EndDialog( hdlg, TRUE );
            return TRUE;
         } 
         break;
      } 
      /*----------------------------------------------------------------------*/   
      /*                                                                      */
      /*----------------------------------------------------------------------*/   
      default:
         return FALSE;
   }
   return FALSE;
}

/******************************************************************************/
/*                                                                            */
/* Funktionsname: ErrorBox                                                    */
/*                                                                            */
/* Beschreibung :                                                             */
/*                                                                            */
/* -------------------------------------------------------------------------- */
/* Parameter    :                                                             */
/*                                                                            */
/* Rueckgabewert: void                                                        */
/*                                                                            */
/* Bemerkungen  :                                                             */
/*                                                                            */
/* -------------------------------------------------------------------------- */
/* Aenderungshistorie - Version 01.00                                         */
/*                                                                            */
/* Datum    -    Modifikation                                                 */
/* 23.01.96      Entwurf (MGW)                                                */
/******************************************************************************/
static void ErrorBox( HWND hwnd, int Err, LPSTR szInfo )
{                              
   char szBuf1[MAXLENSTRING];
   char szBuf2[MAXLENSTRING];
   
   if (szInfo)
   {
      LoadString( hInstGl, Err, szBuf2, MAXLENSTRING );  
      wsprintf( szBuf1, szBuf2, szInfo );
   }
   else
      LoadString( hInstGl, Err, szBuf1, MAXLENSTRING );  

   MessageBox( hwnd, szBuf1, NULL, MB_OK | MB_ICONSTOP );  
}

/******************************************************************************/
/*                                                                            */
/* Funktionsname: WriteMsg                                                    */
/*                                                                            */
/* Beschreibung :                                                             */
/*                                                                            */
/* -------------------------------------------------------------------------- */
/* Parameter    :                                                             */
/*                                                                            */
/* Rueckgabewert: void                                                        */
/*                                                                            */
/* Bemerkungen  :                                                             */
/*                                                                            */
/* -------------------------------------------------------------------------- */
/* Aenderungshistorie - Version 01.00                                         */
/*                                                                            */
/* Datum    -    Modifikation                                                 */
/* 23.01.96 -    Entwurf (MGW)                                                */
/* 30.09.96 -    AnsiToOem ergaenzt (MGW)                                     */
/******************************************************************************/
static void WriteMsg( HWND hwnd, char *Options, char Token, FILE *file )
{
   static char eos = '\0';
   static char cr  = (char) 13;
   static char lf  = (char) 10;
   static char szBuf[MAXLENSTRING];
   static int  MsgLen;
   static int  DatLen;
          int  FeldNr;
          int  FeldPos;
          BOOL fOK;
            
   /*-------------------------------------------------------------------------*/                               
   /* Laenge ermitteln                                                        */
   /*-------------------------------------------------------------------------*/                               
   MsgLen = 4;                                      /*  Laengenangabe + Token */                                
   if (Options[NAME_ID            ]) MsgLen += 1+GetDlgItemText(hwnd,IDC_NAME_ID            ,szBuf,MAXLENSTRING);
   if (Options[VORNAME_ID         ]) MsgLen += 1+GetDlgItemText(hwnd,IDC_VORNAME_ID         ,szBuf,MAXLENSTRING); 
   if (Options[GEBURTSDATUM_ID    ]) MsgLen += 1+GetDlgItemText(hwnd,IDC_GEBURTSDATUM_ID    ,szBuf,MAXLENSTRING);      
   if (Options[EXT_KARTEINUMMER_ID]) MsgLen += 1+GetDlgItemText(hwnd,IDC_EXT_KARTEINUMMER_ID,szBuf,MAXLENSTRING);         
   
   if (Options[NAME               ]) MsgLen += 1+GetDlgItemText(hwnd,IDC_NAME               ,szBuf,MAXLENSTRING);         
   if (Options[VORNAME            ]) MsgLen += 1+GetDlgItemText(hwnd,IDC_VORNAME            ,szBuf,MAXLENSTRING);         
   if (Options[GEBURTSDATUM       ]) MsgLen += 1+GetDlgItemText(hwnd,IDC_GEBURTSDATUM       ,szBuf,MAXLENSTRING);         
   if (Options[EXT_KARTEINUMMER   ]) MsgLen += 1+GetDlgItemText(hwnd,IDC_EXT_KARTEINUMMER   ,szBuf,MAXLENSTRING);         
   if (Options[GESCHLECHT         ]) MsgLen += 1+GetDlgItemText(hwnd,IDC_GESCHLECHT         ,szBuf,MAXLENSTRING);         
   if (Options[STAMMBEHANDLER     ]) MsgLen += 1+GetDlgItemText(hwnd,IDC_STAMMBEHANDLER     ,szBuf,MAXLENSTRING);         
   if (Options[SCHWANGER          ]) MsgLen += 1+GetDlgItemText(hwnd,IDC_SCHWANGER          ,szBuf,MAXLENSTRING);         
   
   if (Options[STATION            ]) MsgLen += 1+GetDlgItemText(hwnd,IDC_STATION            ,szBuf,MAXLENSTRING);         
   if (Options[DATUM              ]) MsgLen += 1+GetDlgItemText(hwnd,IDC_DATUM              ,szBuf,MAXLENSTRING);                       
   if (Options[ZEIT               ]) MsgLen += 1+GetDlgItemText(hwnd,IDC_ZEIT               ,szBuf,MAXLENSTRING);         
   if (Options[SENDER             ]) MsgLen += 1+GetDlgItemText(hwnd,IDC_SENDER             ,szBuf,MAXLENSTRING);         
   if (Options[EMPFAENGER         ]) MsgLen += 1+GetDlgItemText(hwnd,IDC_EMPFAENGER         ,szBuf,MAXLENSTRING);         
   
   if (Options[AUFTRAGSNUMMER     ]) MsgLen += 1+GetDlgItemText(hwnd,IDC_AUFTRAGSNUMMER     ,szBuf,MAXLENSTRING);
   if (Options[AUFNAHMENUMMER     ]) MsgLen += 1+GetDlgItemText(hwnd,IDC_AUFNAHMENUMMER     ,szBuf,MAXLENSTRING);         
   if (Options[AUFNAHMETYP        ]) MsgLen += 1+GetDlgItemText(hwnd,IDC_AUFNAHMETYP        ,szBuf,MAXLENSTRING);         
   if (Options[AUFNAHMEDATUM      ]) MsgLen += 1+GetDlgItemText(hwnd,IDC_AUFNAHMEDATUM      ,szBuf,MAXLENSTRING);         
   if (Options[AUFNAHMEZEIT       ]) MsgLen += 1+GetDlgItemText(hwnd,IDC_AUFNAHMEZEIT       ,szBuf,MAXLENSTRING);         
   if (Options[VERANTWORTLICHER   ]) MsgLen += 1+GetDlgItemText(hwnd,IDC_VERANTWORTLICHER   ,szBuf,MAXLENSTRING);         
   if (Options[BEGRUENDUNG        ]) MsgLen += 1+GetDlgItemText(hwnd,IDC_BEGRUENDUNG        ,szBuf,MAXLENSTRING);         
   if (Options[BEFUND             ]) MsgLen += 1+GetDlgItemText(hwnd,IDC_BEFUND             ,szBuf,MAXLENSTRING);         
   if (Options[STRAHLDAUER        ]) MsgLen += 1+GetDlgItemText(hwnd,IDC_STRAHLDAUER        ,szBuf,MAXLENSTRING);         
   if (Options[ROEHRENSPANNUNG    ]) MsgLen += 1+GetDlgItemText(hwnd,IDC_ROEHRENSPANNUNG    ,szBuf,MAXLENSTRING);         
   if (Options[ANODENSTROM        ]) MsgLen += 1+GetDlgItemText(hwnd,IDC_ANODENSTROM        ,szBuf,MAXLENSTRING);         
   if (Options[BILDDATEI          ]) MsgLen += 1+GetDlgItemText(hwnd,IDC_BILDDATEI          ,szBuf,MAXLENSTRING);

   MsgLen += 2;                                     /* Zeilenumbruch am Ende  */
   
   /*-------------------------------------------------------------------------*/                               
   /* Kopf schreiben                                                          */
   /*-------------------------------------------------------------------------*/                               
   fwrite( &MsgLen, sizeof( WORD ), 1, file );
   fwrite( &Token , sizeof( char ), 1, file );
   fwrite( &eos   , sizeof( char ), 1, file );
                          
   /*-------------------------------------------------------------------------*/                               
   /* Nachricht schreiben (solange noch Felder zu bearbeiten sind => do)      */
   /*-------------------------------------------------------------------------*/                               
   FeldNr = 1;

   do
   {
      fOK = FALSE;

      for (FeldPos = MATRIXMIN; FeldPos <= MATRIXMAX; FeldPos++)
      {     
         if (Options[FeldPos] == FeldNr)
         {    
            DatLen = GetDlgItemText( hwnd, ResMtrxGl[FeldPos], szBuf, MAXLENSTRING );
            AnsiToOem( szBuf, szBuf );
            fwrite( szBuf , sizeof( char ), DatLen + 1, file );
            FeldNr++;
            fOK = TRUE;
            break;
         }
      }
   }
   while (fOK);
   
   /*-------------------------------------------------------------------------*/                               
   /* Ende schreiben                                                          */
   /*-------------------------------------------------------------------------*/                               
   fwrite( &cr, sizeof( char ), 1, file );
   fwrite( &lf, sizeof( char ), 1, file );
}

/******************************************************************************/
/*                                                                            */
/* Funktionsname: EnableEdit                                                  */
/*                                                                            */
/* Beschreibung :                                                             */
/*                                                                            */
/* -------------------------------------------------------------------------- */
/* Parameter    : HWND                                                        */
/*                char *                                                      */
/*                                                                            */
/* Rueckgabewert: void                                                        */
/*                                                                            */
/* Bemerkungen  :                                                             */
/*                                                                            */
/* -------------------------------------------------------------------------- */
/* Aenderungshistorie - Version 01.00                                         */
/*                                                                            */
/* Datum    -    Modifikation                                                 */
/* 23.01.96      Entwurf (MGW)                                                */
/******************************************************************************/
static void EnableEdit( HWND hwnd, char *Options )
{
    EnableWindow( GetDlgItem(hwnd,IDT_NAME_ID             ),Options[NAME_ID            ]);                     
    EnableWindow( GetDlgItem(hwnd,IDC_NAME_ID             ),Options[NAME_ID            ]);                     
    EnableWindow( GetDlgItem(hwnd,IDT_VORNAME_ID          ),Options[VORNAME_ID         ]);        
    EnableWindow( GetDlgItem(hwnd,IDC_VORNAME_ID          ),Options[VORNAME_ID         ]);        
    EnableWindow( GetDlgItem(hwnd,IDT_GEBURTSDATUM_ID     ),Options[GEBURTSDATUM_ID    ]);        
    EnableWindow( GetDlgItem(hwnd,IDC_GEBURTSDATUM_ID     ),Options[GEBURTSDATUM_ID    ]);        
    EnableWindow( GetDlgItem(hwnd,IDT_EXT_KARTEINUMMER_ID ),Options[EXT_KARTEINUMMER_ID]);        
    EnableWindow( GetDlgItem(hwnd,IDC_EXT_KARTEINUMMER_ID ),Options[EXT_KARTEINUMMER_ID]);        

    EnableWindow( GetDlgItem(hwnd,IDT_NAME                ),Options[NAME               ]);        
    EnableWindow( GetDlgItem(hwnd,IDC_NAME                ),Options[NAME               ]);        
    EnableWindow( GetDlgItem(hwnd,IDT_VORNAME             ),Options[VORNAME            ]);        
    EnableWindow( GetDlgItem(hwnd,IDC_VORNAME             ),Options[VORNAME            ]);        
    EnableWindow( GetDlgItem(hwnd,IDT_GEBURTSDATUM        ),Options[GEBURTSDATUM       ]);        
    EnableWindow( GetDlgItem(hwnd,IDC_GEBURTSDATUM        ),Options[GEBURTSDATUM       ]);        
    EnableWindow( GetDlgItem(hwnd,IDT_EXT_KARTEINUMMER    ),Options[EXT_KARTEINUMMER   ]);        
    EnableWindow( GetDlgItem(hwnd,IDC_EXT_KARTEINUMMER    ),Options[EXT_KARTEINUMMER   ]);        
    EnableWindow( GetDlgItem(hwnd,IDT_GESCHLECHT          ),Options[GESCHLECHT         ]);        
    EnableWindow( GetDlgItem(hwnd,IDC_GESCHLECHT          ),Options[GESCHLECHT         ]);        
    EnableWindow( GetDlgItem(hwnd,IDT_STAMMBEHANDLER      ),Options[STAMMBEHANDLER     ]);        
    EnableWindow( GetDlgItem(hwnd,IDC_STAMMBEHANDLER      ),Options[STAMMBEHANDLER     ]);        
    EnableWindow( GetDlgItem(hwnd,IDT_SCHWANGER           ),Options[SCHWANGER          ]);        
    EnableWindow( GetDlgItem(hwnd,IDC_SCHWANGER           ),Options[SCHWANGER          ]);        

    EnableWindow( GetDlgItem(hwnd,IDT_STATION             ),Options[STATION            ]);        
    EnableWindow( GetDlgItem(hwnd,IDC_STATION             ),Options[STATION            ]);        
    EnableWindow( GetDlgItem(hwnd,IDT_DATUM               ),Options[DATUM              ]);        
    EnableWindow( GetDlgItem(hwnd,IDC_DATUM               ),Options[DATUM              ]);        
    EnableWindow( GetDlgItem(hwnd,IDT_ZEIT                ),Options[ZEIT               ]);        
    EnableWindow( GetDlgItem(hwnd,IDC_ZEIT                ),Options[ZEIT               ]);        
    EnableWindow( GetDlgItem(hwnd,IDT_SENDER              ),Options[SENDER             ]);        
    EnableWindow( GetDlgItem(hwnd,IDC_SENDER              ),Options[SENDER             ]);        
    EnableWindow( GetDlgItem(hwnd,IDT_EMPFAENGER          ),Options[EMPFAENGER         ]);        
    EnableWindow( GetDlgItem(hwnd,IDC_EMPFAENGER          ),Options[EMPFAENGER         ]);        

    EnableWindow( GetDlgItem(hwnd,IDT_AUFTRAGSNUMMER      ),Options[AUFTRAGSNUMMER     ]);        
    EnableWindow( GetDlgItem(hwnd,IDC_AUFTRAGSNUMMER      ),Options[AUFTRAGSNUMMER     ]);        
    EnableWindow( GetDlgItem(hwnd,IDT_AUFNAHMENUMMER      ),Options[AUFNAHMENUMMER     ]);        
    EnableWindow( GetDlgItem(hwnd,IDC_AUFNAHMENUMMER      ),Options[AUFNAHMENUMMER     ]);        
    EnableWindow( GetDlgItem(hwnd,IDT_AUFNAHMETYP         ),Options[AUFNAHMETYP        ]);        
    EnableWindow( GetDlgItem(hwnd,IDC_AUFNAHMETYP         ),Options[AUFNAHMETYP        ]);        
    EnableWindow( GetDlgItem(hwnd,IDT_AUFNAHMEDATUM       ),Options[AUFNAHMEDATUM      ]);        
    EnableWindow( GetDlgItem(hwnd,IDC_AUFNAHMEDATUM       ),Options[AUFNAHMEDATUM      ]);        
    EnableWindow( GetDlgItem(hwnd,IDT_AUFNAHMEZEIT        ),Options[AUFNAHMEZEIT       ]);        
    EnableWindow( GetDlgItem(hwnd,IDC_AUFNAHMEZEIT        ),Options[AUFNAHMEZEIT       ]);        
    EnableWindow( GetDlgItem(hwnd,IDT_VERANTWORTLICHER    ),Options[VERANTWORTLICHER   ]);        
    EnableWindow( GetDlgItem(hwnd,IDC_VERANTWORTLICHER    ),Options[VERANTWORTLICHER   ]);        
    EnableWindow( GetDlgItem(hwnd,IDT_BEGRUENDUNG         ),Options[BEGRUENDUNG        ]);        
    EnableWindow( GetDlgItem(hwnd,IDC_BEGRUENDUNG         ),Options[BEGRUENDUNG        ]);        
    EnableWindow( GetDlgItem(hwnd,IDT_BEFUND              ),Options[BEFUND             ]);        
    EnableWindow( GetDlgItem(hwnd,IDC_BEFUND              ),Options[BEFUND             ]);        
    EnableWindow( GetDlgItem(hwnd,IDT_STRAHLDAUER         ),Options[STRAHLDAUER        ]);        
    EnableWindow( GetDlgItem(hwnd,IDC_STRAHLDAUER         ),Options[STRAHLDAUER        ]);        
    EnableWindow( GetDlgItem(hwnd,IDT_ROEHRENSPANNUNG     ),Options[ROEHRENSPANNUNG    ]);        
    EnableWindow( GetDlgItem(hwnd,IDC_ROEHRENSPANNUNG     ),Options[ROEHRENSPANNUNG    ]);        
    EnableWindow( GetDlgItem(hwnd,IDT_ANODENSTROM         ),Options[ANODENSTROM        ]);        
    EnableWindow( GetDlgItem(hwnd,IDC_ANODENSTROM         ),Options[ANODENSTROM        ]);        
    EnableWindow( GetDlgItem(hwnd,IDT_BILDDATEI           ),Options[BILDDATEI          ]);
    EnableWindow( GetDlgItem(hwnd,IDC_BILDDATEI           ),Options[BILDDATEI          ]);
}

/******************************************************************************/
/*                                                                            */
/* Funktionsname: Limittext                                                   */
/*                                                                            */
/* Beschreibung :                                                             */
/*                                                                            */
/* -------------------------------------------------------------------------- */
/* Parameter    : HWND                                                        */
/*                BOOL                                                        */
/*                                                                            */
/* Rueckgabewert: void                                                        */
/*                                                                            */
/* Bemerkungen  :                                                             */
/*                                                                            */
/* -------------------------------------------------------------------------- */
/* Aenderungshistorie - Version 01.00                                         */
/*                                                                            */
/* Datum    -    Modifikation                                                 */
/* 23.01.96      Entwurf (MGW)                                                */
/******************************************************************************/
/* Hildsroutine */
static void MyLimText( HWND hwnd, int id, int len, BOOL fLimit )      
{                             
   static char szBuf[MAXLENSTRING];  
          
   HWND hItem = GetDlgItem( hwnd, id );
   
   SendMessage( hItem, EM_LIMITTEXT, fLimit ? len : MAXLENSTRING - 1, 0 );

   if (fLimit)
   {
       GetWindowText( hItem, szBuf, sizeof( szBuf ) );
       szBuf[len] = EOS;
       SetWindowText( hItem, szBuf );
   }   
}

static void LimitText( HWND hwnd, BOOL fLimit )
{
   MyLimText( hwnd, IDC_MAILSLOT            , MAXLENPATH-1, TRUE );
   
   MyLimText( hwnd, IDC_NAME_ID             , 32, fLimit );
   MyLimText( hwnd, IDC_VORNAME_ID          , 32, fLimit );                  
   MyLimText( hwnd, IDC_GEBURTSDATUM_ID     , 10, fLimit );       
   MyLimText( hwnd, IDC_EXT_KARTEINUMMER_ID , 20, fLimit );       
   
   MyLimText( hwnd, IDC_NAME                , 32, fLimit );                           
   MyLimText( hwnd, IDC_VORNAME             , 32, fLimit );                       
   MyLimText( hwnd, IDC_GEBURTSDATUM        , 10, fLimit );                  
   MyLimText( hwnd, IDC_EXT_KARTEINUMMER    , 20, fLimit );              
   MyLimText( hwnd, IDC_GESCHLECHT          , 1 , fLimit );                    
   MyLimText( hwnd, IDC_STAMMBEHANDLER      , 12, fLimit );                
   MyLimText( hwnd, IDC_SCHWANGER           , 1 , fLimit );                     
   
   MyLimText( hwnd, IDC_STATION             , 20, fLimit );                       
   MyLimText( hwnd, IDC_DATUM               , 10, fLimit );                         
   MyLimText( hwnd, IDC_ZEIT                , 8 , fLimit );                          
   MyLimText( hwnd, IDC_SENDER              , 20, fLimit );                        
   MyLimText( hwnd, IDC_EMPFAENGER          , 20, fLimit );                    
   
   MyLimText( hwnd, IDC_AUFTRAGSNUMMER      , 10, fLimit );
   MyLimText( hwnd, IDC_AUFNAHMENUMMER      , 10, fLimit );                
   MyLimText( hwnd, IDC_AUFNAHMETYP         , 4 , fLimit );                   
   MyLimText( hwnd, IDC_AUFNAHMEDATUM       , 10, fLimit );                 
   MyLimText( hwnd, IDC_AUFNAHMEZEIT        , 8 , fLimit );                  
   MyLimText( hwnd, IDC_VERANTWORTLICHER    , 12, fLimit );              
   MyLimText( hwnd, IDC_BEGRUENDUNG         , 31, fLimit );                   
   MyLimText( hwnd, IDC_BEFUND              , 99, fLimit );                        
   MyLimText( hwnd, IDC_STRAHLDAUER         , 5 , fLimit );                   
   MyLimText( hwnd, IDC_ROEHRENSPANNUNG     , 5 , fLimit );               
   MyLimText( hwnd, IDC_ANODENSTROM         , 5 , fLimit );                   
   MyLimText( hwnd, IDC_BILDDATEI           , 99, fLimit );                       
}

/******************************************************************************/
/*                                                                            */
/* Funktionsname: InitMatrix                                                  */
/*                                                                            */
/* Beschreibung :                                                             */
/*                                                                            */
/* -------------------------------------------------------------------------- */
/* Parameter    :                                                             */
/*                                                                            */
/* Rueckgabewert: void                                                        */
/*                                                                            */
/* Bemerkungen  :                                                             */
/*                                                                            */
/* -------------------------------------------------------------------------- */
/* Aenderungshistorie - Version 01.00                                         */
/*                                                                            */
/* Datum    -    Modifikation                                                 */
/* 23.01.96      Entwurf (MGW)                                                */
/******************************************************************************/
static void InitMatrix()
{
   /*-------------------------------------------------------------------------*/
   /* Zusammenhang mit Ressourcen-ID                                          */
   /*-------------------------------------------------------------------------*/
   ResMtrxGl[NAME_ID            ] = IDC_NAME_ID;                      
   ResMtrxGl[VORNAME_ID         ] = IDC_VORNAME_ID;        
   ResMtrxGl[GEBURTSDATUM_ID    ] = IDC_GEBURTSDATUM_ID;        
   ResMtrxGl[EXT_KARTEINUMMER_ID] = IDC_EXT_KARTEINUMMER_ID;        
   ResMtrxGl[NAME               ] = IDC_NAME;        
   ResMtrxGl[VORNAME            ] = IDC_VORNAME;        
   ResMtrxGl[GEBURTSDATUM       ] = IDC_GEBURTSDATUM;        
   ResMtrxGl[EXT_KARTEINUMMER   ] = IDC_EXT_KARTEINUMMER;        
   ResMtrxGl[GESCHLECHT         ] = IDC_GESCHLECHT;        
   ResMtrxGl[STAMMBEHANDLER     ] = IDC_STAMMBEHANDLER;        
   ResMtrxGl[SCHWANGER          ] = IDC_SCHWANGER;        
   ResMtrxGl[STATION            ] = IDC_STATION;        
   ResMtrxGl[DATUM              ] = IDC_DATUM;        
   ResMtrxGl[ZEIT               ] = IDC_ZEIT;        
   ResMtrxGl[SENDER             ] = IDC_SENDER;        
   ResMtrxGl[EMPFAENGER         ] = IDC_EMPFAENGER;        
   ResMtrxGl[AUFTRAGSNUMMER     ] = IDC_AUFTRAGSNUMMER;        
   ResMtrxGl[AUFNAHMENUMMER     ] = IDC_AUFNAHMENUMMER;
   ResMtrxGl[AUFNAHMETYP        ] = IDC_AUFNAHMETYP;        
   ResMtrxGl[AUFNAHMEDATUM      ] = IDC_AUFNAHMEDATUM;        
   ResMtrxGl[AUFNAHMEZEIT       ] = IDC_AUFNAHMEZEIT;        
   ResMtrxGl[VERANTWORTLICHER   ] = IDC_VERANTWORTLICHER;        
   ResMtrxGl[BEGRUENDUNG        ] = IDC_BEGRUENDUNG;        
   ResMtrxGl[BEFUND             ] = IDC_BEFUND;        
   ResMtrxGl[STRAHLDAUER        ] = IDC_STRAHLDAUER;        
   ResMtrxGl[ROEHRENSPANNUNG    ] = IDC_ROEHRENSPANNUNG;        
   ResMtrxGl[ANODENSTROM        ] = IDC_ANODENSTROM;        
   ResMtrxGl[BILDDATEI          ] = IDC_BILDDATEI;
  
   /*-------------------------------------------------------------------------*/
   /* Token A                                                                 */
   /*-------------------------------------------------------------------------*/
   MatrixAGl[NAME_ID            ] =  1;                      
   MatrixAGl[VORNAME_ID         ] =  2;        
   MatrixAGl[GEBURTSDATUM_ID    ] =  3;        
   MatrixAGl[EXT_KARTEINUMMER_ID] =  4;        
   MatrixAGl[NAME               ] =  0;        
   MatrixAGl[VORNAME            ] =  0;        
   MatrixAGl[GEBURTSDATUM       ] =  0;        
   MatrixAGl[EXT_KARTEINUMMER   ] =  0;        
   MatrixAGl[GESCHLECHT         ] =  0;        
   MatrixAGl[STAMMBEHANDLER     ] =  0;        
   MatrixAGl[SCHWANGER          ] =  0;        
   MatrixAGl[STATION            ] =  5;        
   MatrixAGl[DATUM              ] =  6;        
   MatrixAGl[ZEIT               ] =  7;        
   MatrixAGl[SENDER             ] =  8;        
   MatrixAGl[EMPFAENGER         ] =  9;        
   MatrixAGl[AUFTRAGSNUMMER     ] =  0;        
   MatrixAGl[AUFNAHMENUMMER     ] = 10;
   MatrixAGl[AUFNAHMETYP        ] =  0;        
   MatrixAGl[AUFNAHMEDATUM      ] =  0;        
   MatrixAGl[AUFNAHMEZEIT       ] =  0;        
   MatrixAGl[VERANTWORTLICHER   ] =  0;        
   MatrixAGl[BEGRUENDUNG        ] =  0;        
   MatrixAGl[BEFUND             ] =  0;        
   MatrixAGl[STRAHLDAUER        ] =  0;        
   MatrixAGl[ROEHRENSPANNUNG    ] =  0;        
   MatrixAGl[ANODENSTROM        ] =  0;        
   MatrixAGl[BILDDATEI          ] =  0;
  
   /*-------------------------------------------------------------------------*/
   /* Token I                                                                 */
   /*-------------------------------------------------------------------------*/
   MatrixIGl[NAME_ID            ] =  1;                      
   MatrixIGl[VORNAME_ID         ] =  2;        
   MatrixIGl[GEBURTSDATUM_ID    ] =  3;        
   MatrixIGl[EXT_KARTEINUMMER_ID] =  4;        
   MatrixIGl[NAME               ] =  0;        
   MatrixIGl[VORNAME            ] =  0;        
   MatrixIGl[GEBURTSDATUM       ] =  0;        
   MatrixIGl[EXT_KARTEINUMMER   ] =  0;        
   MatrixIGl[GESCHLECHT         ] =  0;        
   MatrixIGl[STAMMBEHANDLER     ] =  0;        
   MatrixIGl[SCHWANGER          ] =  0;        
   MatrixIGl[STATION            ] =  0;        
   MatrixIGl[DATUM              ] =  0;        
   MatrixIGl[ZEIT               ] =  0;        
   MatrixIGl[SENDER             ] = 15;        
   MatrixIGl[EMPFAENGER         ] = 16;        
   MatrixIGl[AUFTRAGSNUMMER     ] =  0;        
   MatrixIGl[AUFNAHMENUMMER     ] =  5;
   MatrixIGl[AUFNAHMETYP        ] =  6;        
   MatrixIGl[AUFNAHMEDATUM      ] =  7;        
   MatrixIGl[AUFNAHMEZEIT       ] =  8;        
   MatrixIGl[VERANTWORTLICHER   ] =  9;        
   MatrixIGl[BEGRUENDUNG        ] = 10;        
   MatrixIGl[BEFUND             ] = 11;        
   MatrixIGl[STRAHLDAUER        ] = 12;        
   MatrixIGl[ROEHRENSPANNUNG    ] = 13;        
   MatrixIGl[ANODENSTROM        ] = 14;        
   MatrixIGl[BILDDATEI          ] =  0;
        
   /*-------------------------------------------------------------------------*/
   /* Token M                                                                 */
   /*-------------------------------------------------------------------------*/
   MatrixMGl[NAME_ID            ] =  1;                      
   MatrixMGl[VORNAME_ID         ] =  2;        
   MatrixMGl[GEBURTSDATUM_ID    ] =  3;        
   MatrixMGl[EXT_KARTEINUMMER_ID] =  4;        
   MatrixMGl[NAME               ] =  0;        
   MatrixMGl[VORNAME            ] =  0;        
   MatrixMGl[GEBURTSDATUM       ] =  0;        
   MatrixMGl[EXT_KARTEINUMMER   ] =  0;        
   MatrixMGl[GESCHLECHT         ] =  0;        
   MatrixMGl[STAMMBEHANDLER     ] =  0;        
   MatrixMGl[SCHWANGER          ] =  0;        
   MatrixMGl[STATION            ] =  0;        
   MatrixMGl[DATUM              ] =  0;        
   MatrixMGl[ZEIT               ] =  0;        
   MatrixMGl[SENDER             ] = 10;        
   MatrixMGl[EMPFAENGER         ] = 11;        
   MatrixMGl[AUFTRAGSNUMMER     ] =  0;        
   MatrixMGl[AUFNAHMENUMMER     ] = 12;
   MatrixMGl[AUFNAHMETYP        ] =  5;        
   MatrixMGl[AUFNAHMEDATUM      ] =  6;        
   MatrixMGl[AUFNAHMEZEIT       ] =  7;        
   MatrixMGl[VERANTWORTLICHER   ] =  8;        
   MatrixMGl[BEGRUENDUNG        ] =  0;        
   MatrixMGl[BEFUND             ] =  0;        
   MatrixMGl[STRAHLDAUER        ] =  0;        
   MatrixMGl[ROEHRENSPANNUNG    ] =  0;        
   MatrixMGl[ANODENSTROM        ] =  0;        
   MatrixMGl[BILDDATEI          ] =  9;

   /*-------------------------------------------------------------------------*/
   /* Token N                                                                 */
   /*-------------------------------------------------------------------------*/
   MatrixNGl[NAME_ID            ] =  0;                      
   MatrixNGl[VORNAME_ID         ] =  0;        
   MatrixNGl[GEBURTSDATUM_ID    ] =  0;        
   MatrixNGl[EXT_KARTEINUMMER_ID] =  0;        
   MatrixNGl[NAME               ] =  1;        
   MatrixNGl[VORNAME            ] =  2;        
   MatrixNGl[GEBURTSDATUM       ] =  3;        
   MatrixNGl[EXT_KARTEINUMMER   ] =  4;        
   MatrixNGl[GESCHLECHT         ] =  5;        
   MatrixNGl[STAMMBEHANDLER     ] =  6;        
   MatrixNGl[SCHWANGER          ] =  0;        
   MatrixNGl[STATION            ] =  0;        
   MatrixNGl[DATUM              ] =  0;        
   MatrixNGl[ZEIT               ] =  0;        
   MatrixNGl[SENDER             ] =  7;        
   MatrixNGl[EMPFAENGER         ] =  8;        
   MatrixNGl[AUFTRAGSNUMMER     ] =  0;        
   MatrixNGl[AUFNAHMENUMMER     ] =  0;
   MatrixNGl[AUFNAHMETYP        ] =  0;        
   MatrixNGl[AUFNAHMEDATUM      ] =  0;        
   MatrixNGl[AUFNAHMEZEIT       ] =  0;        
   MatrixNGl[VERANTWORTLICHER   ] =  0;        
   MatrixNGl[BEGRUENDUNG        ] =  0;        
   MatrixNGl[BEFUND             ] =  0;        
   MatrixNGl[STRAHLDAUER        ] =  0;        
   MatrixNGl[ROEHRENSPANNUNG    ] =  0;        
   MatrixNGl[ANODENSTROM        ] =  0;        
   MatrixNGl[BILDDATEI          ] =  0;

   /*-------------------------------------------------------------------------*/
   /* Token R                                                                 */
   /*-------------------------------------------------------------------------*/
   MatrixRGl[NAME_ID            ] =  2;                      
   MatrixRGl[VORNAME_ID         ] =  3;        
   MatrixRGl[GEBURTSDATUM_ID    ] =  4;        
   MatrixRGl[EXT_KARTEINUMMER_ID] =  5;        
   MatrixRGl[NAME               ] =  0;        
   MatrixRGl[VORNAME            ] =  0;        
   MatrixRGl[GEBURTSDATUM       ] =  0;        
   MatrixRGl[EXT_KARTEINUMMER   ] =  0;        
   MatrixRGl[GESCHLECHT         ] =  0;        
   MatrixRGl[STAMMBEHANDLER     ] =  0;        
   MatrixRGl[SCHWANGER          ] =  0;        
   MatrixRGl[STATION            ] =  0;        
   MatrixRGl[DATUM              ] =  0;        
   MatrixRGl[ZEIT               ] =  0;        
   MatrixRGl[SENDER             ] =  6;        
   MatrixRGl[EMPFAENGER         ] =  7;        
   MatrixRGl[AUFTRAGSNUMMER     ] =  1;        
   MatrixRGl[AUFNAHMENUMMER     ] =  0;
   MatrixRGl[AUFNAHMETYP        ] =  0;        
   MatrixRGl[AUFNAHMEDATUM      ] =  0;        
   MatrixRGl[AUFNAHMEZEIT       ] =  0;        
   MatrixRGl[VERANTWORTLICHER   ] =  0;        
   MatrixRGl[BEGRUENDUNG        ] =  0;        
   MatrixRGl[BEFUND             ] =  0;        
   MatrixRGl[STRAHLDAUER        ] =  0;        
   MatrixRGl[ROEHRENSPANNUNG    ] =  0;        
   MatrixRGl[ANODENSTROM        ] =  0;        
   MatrixRGl[BILDDATEI          ] =  0;

   /*-------------------------------------------------------------------------*/
   /* Token S                                                                 */
   /*-------------------------------------------------------------------------*/
   MatrixSGl[NAME_ID            ] =  1;                      
   MatrixSGl[VORNAME_ID         ] =  2;        
   MatrixSGl[GEBURTSDATUM_ID    ] =  3;        
   MatrixSGl[EXT_KARTEINUMMER_ID] =  4;        
   MatrixSGl[NAME               ] =  0;        
   MatrixSGl[VORNAME            ] =  0;        
   MatrixSGl[GEBURTSDATUM       ] =  0;        
   MatrixSGl[EXT_KARTEINUMMER   ] =  0;        
   MatrixSGl[GESCHLECHT         ] =  0;        
   MatrixSGl[STAMMBEHANDLER     ] =  0;        
   MatrixSGl[SCHWANGER          ] =  0;        
   MatrixSGl[STATION            ] =  5;        
   MatrixSGl[DATUM              ] =  6;        
   MatrixSGl[ZEIT               ] =  7;        
   MatrixSGl[SENDER             ] =  8;        
   MatrixSGl[EMPFAENGER         ] =  9;        
   MatrixSGl[AUFTRAGSNUMMER     ] =  0;        
   MatrixSGl[AUFNAHMENUMMER     ] =  0;
   MatrixSGl[AUFNAHMETYP        ] =  0;        
   MatrixSGl[AUFNAHMEDATUM      ] =  0;        
   MatrixSGl[AUFNAHMEZEIT       ] =  0;        
   MatrixSGl[VERANTWORTLICHER   ] =  0;        
   MatrixSGl[BEGRUENDUNG        ] =  0;        
   MatrixSGl[BEFUND             ] =  0;        
   MatrixSGl[STRAHLDAUER        ] =  0;        
   MatrixSGl[ROEHRENSPANNUNG    ] =  0;        
   MatrixSGl[ANODENSTROM        ] =  0;        
   MatrixSGl[BILDDATEI          ] =  0;

   /*-------------------------------------------------------------------------*/
   /* Token T                                                                 */
   /*-------------------------------------------------------------------------*/
   MatrixTGl[NAME_ID            ] =  2;                      
   MatrixTGl[VORNAME_ID         ] =  3;        
   MatrixTGl[GEBURTSDATUM_ID    ] =  4;        
   MatrixTGl[EXT_KARTEINUMMER_ID] =  5;        
   MatrixTGl[NAME               ] =  0;        
   MatrixTGl[VORNAME            ] =  0;        
   MatrixTGl[GEBURTSDATUM       ] =  0;        
   MatrixTGl[EXT_KARTEINUMMER   ] =  0;        
   MatrixTGl[GESCHLECHT         ] =  7;        
   MatrixTGl[STAMMBEHANDLER     ] =  0;        
   MatrixTGl[SCHWANGER          ] =  8;        
   MatrixTGl[STATION            ] =  0;        
   MatrixTGl[DATUM              ] =  0;        
   MatrixTGl[ZEIT               ] =  0;        
   MatrixTGl[SENDER             ] = 18;        
   MatrixTGl[EMPFAENGER         ] = 19;        
   MatrixTGl[AUFTRAGSNUMMER     ] =  1;        
   MatrixTGl[AUFNAHMENUMMER     ] =  6;
   MatrixTGl[AUFNAHMETYP        ] =  9;        
   MatrixTGl[AUFNAHMEDATUM      ] = 10;        
   MatrixTGl[AUFNAHMEZEIT       ] = 11;        
   MatrixTGl[VERANTWORTLICHER   ] = 12;        
   MatrixTGl[BEGRUENDUNG        ] = 13;        
   MatrixTGl[BEFUND             ] = 14;        
   MatrixTGl[STRAHLDAUER        ] = 15;        
   MatrixTGl[ROEHRENSPANNUNG    ] = 16;        
   MatrixTGl[ANODENSTROM        ] = 17;        
   MatrixTGl[BILDDATEI          ] =  0;

   /*-------------------------------------------------------------------------*/
   /* Token U                                                                 */
   /*-------------------------------------------------------------------------*/
   MatrixUGl[NAME_ID            ] =  1;                      
   MatrixUGl[VORNAME_ID         ] =  2;        
   MatrixUGl[GEBURTSDATUM_ID    ] =  3;        
   MatrixUGl[EXT_KARTEINUMMER_ID] =  4;        
   MatrixUGl[NAME               ] =  5;        
   MatrixUGl[VORNAME            ] =  6;        
   MatrixUGl[GEBURTSDATUM       ] =  7;        
   MatrixUGl[EXT_KARTEINUMMER   ] =  8;        
   MatrixUGl[GESCHLECHT         ] =  9;        
   MatrixUGl[STAMMBEHANDLER     ] = 10;        
   MatrixUGl[SCHWANGER          ] =  0;        
   MatrixUGl[STATION            ] =  0;        
   MatrixUGl[DATUM              ] =  0;        
   MatrixUGl[ZEIT               ] =  0;        
   MatrixUGl[SENDER             ] = 11;        
   MatrixUGl[EMPFAENGER         ] = 12;        
   MatrixUGl[AUFTRAGSNUMMER     ] =  0;        
   MatrixUGl[AUFNAHMENUMMER     ] =  0;
   MatrixUGl[AUFNAHMETYP        ] =  0;        
   MatrixUGl[AUFNAHMEDATUM      ] =  0;        
   MatrixUGl[AUFNAHMEZEIT       ] =  0;        
   MatrixUGl[VERANTWORTLICHER   ] =  0;        
   MatrixUGl[BEGRUENDUNG        ] =  0;        
   MatrixUGl[BEFUND             ] =  0;        
   MatrixUGl[STRAHLDAUER        ] =  0;        
   MatrixUGl[ROEHRENSPANNUNG    ] =  0;        
   MatrixUGl[ANODENSTROM        ] =  0;        
   MatrixUGl[BILDDATEI          ] =  0;

   /*-------------------------------------------------------------------------*/
   /* Token X                                                                 */
   /*-------------------------------------------------------------------------*/
   MatrixXGl[NAME_ID            ] =  2;                      
   MatrixXGl[VORNAME_ID         ] =  3;        
   MatrixXGl[GEBURTSDATUM_ID    ] =  4;        
   MatrixXGl[EXT_KARTEINUMMER_ID] =  5;        
   MatrixXGl[NAME               ] =  0;        
   MatrixXGl[VORNAME            ] =  0;        
   MatrixXGl[GEBURTSDATUM       ] =  0;        
   MatrixXGl[EXT_KARTEINUMMER   ] =  0;        
   MatrixXGl[GESCHLECHT         ] =  6;        
   MatrixXGl[STAMMBEHANDLER     ] =  0;        
   MatrixXGl[SCHWANGER          ] =  7;        
   MatrixXGl[STATION            ] = 10;        
   MatrixXGl[DATUM              ] = 11;        
   MatrixXGl[ZEIT               ] = 12;        
   MatrixXGl[SENDER             ] = 13;        
   MatrixXGl[EMPFAENGER         ] = 14;        
   MatrixXGl[AUFTRAGSNUMMER     ] =  1;        
   MatrixXGl[AUFNAHMENUMMER     ] =  0;
   MatrixXGl[AUFNAHMETYP        ] =  8;        
   MatrixXGl[AUFNAHMEDATUM      ] =  0;        
   MatrixXGl[AUFNAHMEZEIT       ] =  0;        
   MatrixXGl[VERANTWORTLICHER   ] =  0;        
   MatrixXGl[BEGRUENDUNG        ] =  9;        
   MatrixXGl[BEFUND             ] =  0;        
   MatrixXGl[STRAHLDAUER        ] =  0;        
   MatrixXGl[ROEHRENSPANNUNG    ] =  0;        
   MatrixXGl[ANODENSTROM        ] =  0;        
   MatrixXGl[BILDDATEI          ] =  0;
}                                                                                   

/******************************************************************************/
/*                                                                            */
/* Funktionsname: GenerateStringInc                                           */
/*                                                                            */
/* Beschreibung : Hngt an einen String ein Zahlenbereich an, der mit 001     */
/*                initialisiert wird. Sind die letzten Zeichen eines String   */
/*                bereits eine Zahl, so wird diese Inkrementiert.             */
/*                                                                            */
/* -------------------------------------------------------------------------- */
/* Parameter    : LPSTR   - Zu verarbeitender String                          */
/*                                                                            */
/* Rueckgabewert: BOOL    - FALSE -> Fehler trat auf                          */
/*                        - TRUE  -> Bearbeitung erfolgreich                  */
/*                                                                            */
/* Bemerkungen  :                                                             */
/*                                                                            */
/* -------------------------------------------------------------------------- */
/* Aenderungshistorie - Version 01.00                                         */
/*                                                                            */
/* Datum    -    Modifikation                                                 */
/* 22.03.96      Entwurf (MGW)                                                */
/******************************************************************************/
BOOL GenerateStringInc( LPSTR lpszString )
{
   int  c,w;
   char szHelp[MAXLENSTRING];
   char szRes [MAXLENSTRING];
   WORD wNumber = 0;
     
   strcpy( szHelp, lpszString );
   w = strlen( szHelp );

   if (isdigit( szHelp[ w - 1 ] ))
   {
      for (c = strlen( szHelp ); isdigit( szHelp[c - 1] ); c--)
         ;

      wNumber = (WORD) (1 + atoi( (char*) &szHelp[c] ));
      szHelp[c] = 0;       
   }
   else
      wNumber = 1;

   wsprintf( szRes, "%3.3d", wNumber );  
   strcat( szHelp, szRes );
   strcpy( lpszString, szHelp );
   return TRUE;
}

/******************************************************************************/
/*                                                                            */
/* Funktionsname: GenerateRandomDate                                          */
/*                                                                            */
/* Beschreibung : Erzeugt ein Zufallsdatum, mit Wert zwischen dateMax und     */
/*                dateMin                                                     */
/*                                                                            */
/* -------------------------------------------------------------------------- */
/* Parameter    : SIDATE                                                      */
/*                SIDATE                                                      */
/*                                                                            */
/* Rueckgabewert: SIDATE                                                      */
/*                                                                            */
/* Bemerkungen  :                                                             */
/*                                                                            */
/* -------------------------------------------------------------------------- */
/* Aenderungshistorie - Version 01.00                                         */
/*                                                                            */
/* Datum    -    Modifikation                                                 */
/* 22.03.96      Entwurf (MGW)                                                */
/******************************************************************************/
SIDATE GenerateRandomDate( SIDATE dateMax, SIDATE dateMin )
{
   SIDATE dateRes;
     
   do
   {         
      dateRes.uwYear  = (UWORD) (rand() % (dateMax.uwYear - dateMin.uwYear + 1)) + dateMin.uwYear;
      dateRes.ubMonth = (UBYTE) (rand() % 12 + 1);
      dateRes.ubDay   = (UBYTE) (rand() % 28 + 1);
   }
   while (    dateRes.uwYear >  dateMax.uwYear
          || (dateRes.uwYear == dateMax.uwYear && dateRes.ubMonth >  dateMax.ubMonth) 
          || (dateRes.uwYear == dateMax.uwYear && dateRes.ubMonth == dateMax.ubMonth && dateRes.ubDay > dateMax.ubDay)
          ||  dateRes.uwYear <  dateMin.uwYear
          || (dateRes.uwYear == dateMin.uwYear && dateRes.ubMonth <  dateMin.ubMonth)
          || (dateRes.uwYear == dateMin.uwYear && dateRes.ubMonth == dateMin.ubMonth && dateRes.ubDay < dateMin.ubDay) );
    
   return dateRes;
}                           

/******************************************************************************/
/*                                                                            */
/* Funktionsname: GenerateRandomTime                                          */
/*                                                                            */
/* Beschreibung : Erzeugt eine Zufallszeit                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
/* Parameter    : void                                                        */
/*                                                                            */
/* Rueckgabewert: SITIME                                                      */
/*                                                                            */
/* Bemerkungen  :                                                             */
/*                                                                            */
/* -------------------------------------------------------------------------- */
/* Aenderungshistorie - Version 01.00                                         */
/*                                                                            */
/* Datum    -    Modifikation                                                 */
/* 22.03.96      Entwurf (MGW)                                                */
/******************************************************************************/
SITIME GenerateRandomTime()
{
   SITIME timeRes;
    
   timeRes.ubHour   = (BYTE) (rand() % 24);
   timeRes.ubMinute = (BYTE) (rand() % 60);
   timeRes.ubHour   = (BYTE) (rand() % 60);
    
   return timeRes;
}
