/******************************************************************************/
/*                                                                            */
/* Headername  : siudate.h                                                    */
/*                                                                            */
/* Beschreibung: Schnittstelle zum Modul SiUDate.                             */
/*                                                                            */
/* Autor       : Michael G. Wetzel             Abt.: Siemens AG UB Med DRE    */
/*                                                                            */
/* Copyright (C) Siemens AG 1994 - All Rights Reserved                        */
/* -------------------------------------------------------------------------- */
/* Status      : Freigegeben                                                  */
/* -------------------------------------------------------------------------- */
/* Aenderungshistorie - Version _1.1_                                         */
/*                                                                            */
/* Datum      Modifikation                                                    */
/* 06.01.93 - Entwurf                                                         */
/* 08.02.93 - Uhrzeit-Funktionen (MGW)                                        */
/* 27.10.93 - Review zur NULL - Serie     (K. Schrick   )                     */
/* 01.06.94 - IsDate() toleriert evtl. Nulldatum (Juergen Zimmermann)         */
/* 09.06.94 - + CalcDate() (Juergen Zimmermann)                               */
/* 24.08.94 - Freigabe (Juergen Zimmermann) => V.1.0                          */
/* 21.02.95 - + GetDlgItemDateStr() (Dietmar Keller) => V.1.1                 */
/* 21.02.95 - GetDlgItemDateStr() fuer Nulldatumseingabe erweitert (D.Keller) */
/* 22.02.95 - Review letzte Aenderung (Juergen Zimmermann)                    */
/* 03.07.95 - Integrationstest + Freigabe (Juergen Zimmermann)                */
/*                                                                            */
/******************************************************************************/
#ifndef _SIUDATE_H
#define _SIUDATE_H

/******************************************************************************/
/* Definitionen, Makros, und Konstanten                                       */
/******************************************************************************/

/******************************************************************************/
/* Datentypen                                                                 */
/******************************************************************************/

/******************************************************************************/
/* Prototypen der Public-Funktionen                                           */
/******************************************************************************/
void  WINAPI GetActTime       (   LPUBYTE     lpubHour,
                                  LPUBYTE     lpubMinute,
                                  LPUBYTE     lpubSecond
                              );
void  WINAPI GetActDate       (   LPUWORD     lpuwYear,
                                  LPUBYTE     lpubMonth,
                                  LPUBYTE     lpubDay
                              );
BOOL  WINAPI GetActTimeDateStr(   LPSTR       lpszDateTime,
                                  LPCSTR      lpszDateFormat,
                                  LPCSTR      lpszTimeFormat
                              );
BOOL  WINAPI IsTime           (   UBYTE       ubHour,
                                  UBYTE       ubMinute,
                                  UBYTE       ubSecond
                              );
BOOL  WINAPI IsDate           (   UWORD       uwYear,
                                  UBYTE       ubMonth,
                                  UBYTE       ubDay,
                                  BOOL        fIgnoreZero
                              );
SWORD WINAPI CompareTime      (   UBYTE       ubHour1,
                                  UBYTE       ubMinute1,
                                  UBYTE       ubSecond1,
                                  UBYTE       ubHour2,
                                  UBYTE       ubMinute2,
                                  UBYTE       ubSecond2
                              );
SWORD WINAPI CompareDate      (   UWORD       uwYear1,
                                  UBYTE       ubMonth1,
                                  UBYTE       ubDay1,
                                  UWORD       uwYear2,
                                  UBYTE       ubMonth2,
                                  UBYTE       ubDay2
                              );
BOOL  WINAPI TimeToStr        (   UBYTE       ubHour,
                                  UBYTE       ubMinute,
                                  UBYTE       ubSecond,
                                  LPSTR       lpszTime,
                                  LPCSTR      lpszFormat
                              );
BOOL  WINAPI DateToStr        (   UWORD       uwYear,
                                  UBYTE       ubMonth,
                                  UBYTE       ubDay,
                                  LPSTR       lpszDate,
                                  LPCSTR      lpszFormat
                              );
BOOL  WINAPI GetDlgItemDateStr(   HWND        hDlg, 
                                  UINT        uwIdCtrl,
                                  LPSTR       lpszDate, 
                                  LPCSTR      lpszFormat,
                                  BOOL        fIgnoreZero  
                              );
BOOL  WINAPI StrToTime        (   LPUBYTE     lpubHour,
                                  LPUBYTE     lpubMinute,
                                  LPUBYTE     lpubSecond,
                                  LPCSTR      lpszTime,
                                  LPCSTR      lpszFormat
                              );
BOOL  WINAPI StrToDate        (   LPUWORD     lpuwYear,
                                  LPUBYTE     lpubMonth,
                                  LPUBYTE     lpubDay,
                                  LPCSTR      lpszDate,
                                  LPCSTR      lpszFormat
                              );

/******************************************************************************/
/* Prototypen der Windows-Callback-Funktionen                                 */
/******************************************************************************/

#endif /* _SIUDATE_H */

