﻿// <copyright file="PTestView.xaml.cs" company="Sirona Dental Systems GmbH">
//    Copyright (c) Sirona Dental Systems GmbH. All rights reserved.
// </copyright>

namespace PTest
{
    using System.Windows;
    using System.Windows.Controls;
    using System.Windows.Input;

    /// <summary>
    ///     Interaction logic for PTestView.xaml
    /// </summary>
    public partial class PTestView
    {
        private readonly PTestViewModel _viewModel;

        public static RoutedCommand EnterKeyCmd = new RoutedCommand();

        public PTestView()
        {
            _viewModel = new PTestViewModel();
            InitializeComponent();
            DataContext = _viewModel; // XAML Datacontext Zuweisung
        }

        public void OnEnterExecuted(object sender, ExecutedRoutedEventArgs args)
        {
            IInputElement focusedControl = FocusManager.GetFocusedElement(this);

            var textBox = focusedControl as TextBox;

            if (textBox==null)
                return;

            TraversalRequest request = new TraversalRequest(FocusNavigationDirection.Next);
            request.Wrapped = true;
            textBox.MoveFocus(request);
        }
    }        
}