﻿// <copyright file="RadioButtonCheckedConverter.cs" company="Sirona Dental Systems GmbH">
//    Copyright (c) Sirona Dental Systems GmbH. All rights reserved.
// </copyright>

namespace PTest
{
    using System;
    using System.Globalization;
    using System.Windows.Data;

    /// <summary>
    ///     This converter is used to bind a value to a group of radio buttons, and can be used with an enum, bool, int, etc.
    ///     It depends on the converter parameter, which maps a radio button to a specific value.
    ///     Note: this converter is not designed to work with flag enums (e.g. multiple checkboxes scenario).
    ///     Here is an example of the binding for an enum value:
    /// </summary>
    public class RadioButtonCheckedConverter : IValueConverter
    {
        public object Convert(object value, Type targetType,  object parameter, CultureInfo culture )
        {
            return value.Equals(parameter);
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            return value.Equals(true) ? parameter : Binding.DoNothing;
        }
    }
}
