﻿// <copyright file="Slida.cs" company="Sirona Dental Systems GmbH">
//    Copyright (c) Sirona Dental Systems GmbH. All rights reserved.
// </copyright>

using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PTest
{
    using System;
    using System.IO;
    using System.Windows;
    using Properties;

    class Slida
    {
        public static byte[] GenerateToken(char TokenName, List<string> tokenValues)
        {
            var tokenLen = 4; // Header

            foreach (var token in tokenValues)
                tokenLen += new ASCIIEncoding().GetByteCount(token) + 1;

            tokenLen += 2; // cr lf

            byte[] tokenData = new byte[tokenLen];

            int index = 0;

            var len = (short)tokenLen;

            // Header
            tokenData[index++] = (byte)len;
            tokenData[index++] = (byte)(len >> 8);
            tokenData[index++] = (byte)TokenName;
            tokenData[index++] = 0;

            // Token Data
            foreach (var token in tokenValues)
            {
                var buf = new ASCIIEncoding().GetBytes(token);
                buf.CopyTo(tokenData, index);
                index += buf.Count();
                tokenData[index++] = 0;
            }
            // End marker
            tokenData[index++] = (byte)'\r';
            tokenData[index] = (byte)'\n';

            return tokenData;
        }

        public static void WriteToSlida(string filename, byte[] tokenData)
        {
            try
            {
                using (var fs = new FileStream(filename, FileMode.OpenOrCreate, FileAccess.Write, FileShare.ReadWrite))
                {
                    fs.Seek(0, SeekOrigin.End);
                    fs.Write(tokenData, 0, tokenData.Length);
                    fs.Close();
                }
            }
            catch (Exception e)
            {
                MessageBoxEx.Show( Resources.ApplicationName, Resources.ErrorSlidaWrite + "\n" + e.Message, MessageBoxButton.OK, MessageBoxExImage.Error );
            }
        }
    }
}
